<?php

namespace App\Exports;

use Illuminate\Support\Facades\DB;
use Maatwebsite\Excel\Concerns\FromCollection;
use Maatwebsite\Excel\Concerns\WithStrictNullComparison;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Maatwebsite\Excel\Concerns\WithMapping;

class ConventionsExport implements FromCollection, WithStrictNullComparison, WithHeadings, WithMapping
{
    public function collection()
    {
        return DB::table('convention')->get([
            'BANQUE',
            'ADRESSE',
            'DEPARTEMENTS',
            'TITULAIRE_CONVENTION',
            'PAIE_PTZ',
            'PAIE_CLIENTS',
            'COMM_CLIENTS',
            'PLAFOND_CLIENTS',
            'COMM_PROSPECTS',
            'PLAFOND_PROSPECTS',
            'DETAILS_COMM',
            'DATE_MISE_A_JOUR',
            'TYPE',
            'FICHE',
            'CONTACT_FACT',
            'PROCE_FACT'
        ]);
    }

    public function headings(): array
    {
        return [
            'Banque',
            'Adresse Postale',
            'Départements',
            'Titulaire',
            'PTZ',
            'Paie Clients',
            'Comm. Clients',
            'Plafond Clients',
            'Comm. Prospects',
            'Plafond Prospects',
            'Détails Comm.',
            'Mise à jour',
            'Type',
            'Fiche',
            'Contact Facturation',
            'Process Facturation'
        ];
    }

    public function map($row): array
    {
        return [
            $row->BANQUE,
            $row->ADRESSE,
            $row->DEPARTEMENTS,
            $row->TITULAIRE_CONVENTION,
            $row->PAIE_PTZ ? 'Oui' : 'Non',
            $row->PAIE_CLIENTS ? 'Oui' : 'Non',
            $row->COMM_CLIENTS,
            $row->PLAFOND_CLIENTS,
            $row->COMM_PROSPECTS,
            $row->PLAFOND_PROSPECTS,
            $row->DETAILS_COMM,
            $row->DATE_MISE_A_JOUR,
            $row->TYPE,
            $row->FICHE,
            $row->CONTACT_FACT,
            $row->PROCE_FACT
        ];
    }
}
